#include "stdfer.h"

int isspace(int c) {
    return c == ' ' || c == '\t';
}

int isdigit(int c) {
    return c >= '0' && c <= '9';
}

long atol(const char *nptr) {
    int c;
    long total;
    int sign;
 
    while (isspace((int)(unsigned char) *nptr)) {
        ++nptr;
    }
 
    c = (int)(unsigned char) *nptr++;
    sign = c;
    if (c == '-' || c == '+') {
        c = (int)(unsigned char) *nptr++;
    }
 
    total = 0;
    while (isdigit(c)) {
        total = 10 * total + (c - '0');
        c = (int)(unsigned char) *nptr++;
    }
 
    if (sign == '-') {
        return -total;
    } else {
        return total;
    }
}

int atoi(const char *nptr) {
    return (int) atol(nptr);
}

double atof(char *s)
{
        double a = 0.0;
        int e = 0;
        int c;
        while ((c = *s++) != '\0' && isdigit(c)) {
                a = a*10.0 + (c - '0');
        }
        if (c == '.') {
                while ((c = *s++) != '\0' && isdigit(c)) {
                        a = a*10.0 + (c - '0');
                        e = e-1;
                }
        }
        if (c == 'e' || c == 'E') {
                int sign = 1;
                int i = 0;
                c = *s++;
                if (c == '+')
                        c = *s++;
                else if (c == '-') {
                        c = *s++;
                        sign = -1;
                }
                while (isdigit(c)) {
                        i = i*10 + (c - '0');
                        c = *s++;
                }
                e += i*sign;
        }
        while (e > 0) {
                a *= 10.0;
                e--;
        }
        while (e < 0) {
                a *= 0.1;
                e++;
        }
        return a;
}
